Bug 39983 - [Feature Request] Support Mac OSX 10.7 (Lion) full-screen mode
Summary: [Feature Request] Support Mac OSX 10.7 (Lion) full-screen mode
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
(earliest affected)
3.4.2 release
Hardware: x86-64 (AMD64) Mac OS X (All)
: medium enhancement
Assignee: Not Assigned
QA Contact:
Whiteboard: target:4.2.0
: 43936 58471 64152 68284 (view as bug list)
Depends on:
Blocks: 42082
  Show dependency treegraph
Reported: 2011-08-10 08:41 UTC by Pete K.
Modified: 2015-11-13 11:13 UTC (History)
23 users (show)

See Also:
Crash report or crash signature:

First patch (3.72 KB, text/plain)
2011-09-27 00:18 UTC, Don't use this account, use tml@iki.fi
Second patch, hack in progress (1.28 KB, text/plain)
2011-09-27 00:23 UTC, Don't use this account, use tml@iki.fi
Third patch, hack in progress (3.06 KB, text/plain)
2011-09-27 00:24 UTC, Don't use this account, use tml@iki.fi
Draw in Fullscreen mode (78.76 KB, image/png)
2012-12-24 12:45 UTC, Emir Sarı (away)
SS, missing toolbar (32.73 KB, image/png)
2013-08-01 08:25 UTC, Emir Sarı (away)

Note You need to log in before you can comment on or make changes to this bug.
Description Pete K. 2011-08-10 08:41:43 UTC
I honestly don't know what this would take, but it would be nice if LibreOffice for Mac supported the Mac OS X 10.7 ("Lion") native full-screen mode.  The Mac OS fullscreen mode integrates the fullscreen window into the desktop spaces, making switching between the fullscreen window and other applications very easy.

I know this is low priority, especially since it's for Mac OS only, but I figure I can at least ask... :)

More info can be found at http://developer.apple.com/library/mac/documentation/General/Conceptual/MOSXAppProgrammingGuide/FullScreenApp/FullScreenApp.html
Comment 1 Don't use this account, use tml@iki.fi 2011-09-27 00:15:28 UTC
I think I already did a short writeup on my quick experimentation with adding support for Lion full-screen mode somewhere but can't find it any more;)

So, some time ago (right after Lion was released) I played a bit with adding support for the nice full-screen feature. Basically, getting it working in a quick-and-dirty way was easy, but then getting all the details right is more of a challenge, and would require some user experience expert input... Mainly, to decide how the existing LO full-screen feature should interact with the Lion-style full-screen feature. Not at all? Be superseded by it, but keep the same keyboard shortcut? Etc...

Anyway, in case somebody wants to continue hacking on this, I will attach a couple of diffs.
Comment 2 Don't use this account, use tml@iki.fi 2011-09-27 00:18:16 UTC
Created attachment 51649 [details]
First patch

If I recall correctly, this short diff makes the full-screen button (icon) appear for LO's document windows (and it works).

The code still compiles fine against the 10.4 SDK, and should as far as I see not attempt to use any feature not present on earlier OSes on them.
Comment 3 Don't use this account, use tml@iki.fi 2011-09-27 00:23:26 UTC
Created attachment 51650 [details]
Second patch, hack in progress

This is more hackish, I try to make LO modify its UI when it enters or leaves full-screen mode (like the existing View:Full Screen does). A third patch related to this will follow. This did not really work nicely yet when I stopped hacking on this.

(Basically, it is frustrating to work on stuff like making LO on the Mac more Mac-like when one knows that the NeoOffice people have already been doing that for some time, and they for instance already have support for Lion's new stuff. Duplicating work just because of licensing differences is not especially inspiring. At least not if you would do it in your spare time just for fun.)
Comment 4 Don't use this account, use tml@iki.fi 2011-09-27 00:24:40 UTC
Created attachment 51651 [details]
Third patch, hack in progress

Here then handle the "TOGGLEFULLSCREEN" app event the previous patch generates.
Comment 5 Björn Michaelsen 2011-12-23 12:27:16 UTC
[This is an automated message.]
This bug was filed before the changes to Bugzilla on 2011-10-16. Thus it
started right out as NEW without ever being explicitly confirmed. The bug is
changed to state NEEDINFO for this reason. To move this bug from NEEDINFO back
to NEW please check if the bug still persists with the 3.5.0 beta1 or beta2 prereleases.
Details on how to test the 3.5.0 beta1 can be found at:

more detail on this bulk operation: http://nabble.documentfoundation.org/RFC-Operation-Spamzilla-tp3607474p3607474.html
Comment 6 Andreas G. 2011-12-23 13:55:21 UTC
*** Bug 43936 has been marked as a duplicate of this bug. ***
Comment 7 Andreas G. 2011-12-27 14:57:13 UTC
Until when is it expected? Can it implemented in LibO 3.6?
Comment 8 Clayton Walker 2012-04-10 13:16:25 UTC
A lot of applications currently use the full-screen option merely as just that, a full-screen interface. Nothing custom, of course. Just a few lines to support it.

Since your code apparently works, can we at least push the first patch to get basic full-screen support?
Comment 9 Roman Eisele 2012-05-31 03:16:19 UTC
@Tor Lillqvist:
I think that the question in comment #8 is for you, therefore I add you to the CC list ;-)
Comment 10 Roman Eisele 2012-05-31 03:29:45 UTC
Status back to NEW: it was just set to NEEDINFO by Björn's bulk operation (see comment #5) and never reset as appropriate.
Comment 11 Don't use this account, use tml@iki.fi 2012-05-31 03:39:59 UTC
@Andreas: Read my comments. I have done nothing for this since.

As I said, "this did not really work nicely yet when I stopped hacking on this", so I don't feel like pushing such a work in progress. I also said "in case somebody wants to continue hacking on this"...

I don't have the inspiration to work any more on this issue in my own time, and I am not allocated to work on Mac stuff in my work.
Comment 12 Jorendc 2012-12-19 17:41:28 UTC
*** Bug 58471 has been marked as a duplicate of this bug. ***
Comment 13 Rainer Bielefeld Retired 2012-12-20 09:20:26 UTC
May be some of the AOOo tricks can work for LibO, too?
Comment 14 Don't use this account, use tml@iki.fi 2012-12-20 09:57:14 UTC
What AOO tricks? Do you have any pointers to code or discussion?
Comment 15 Michael Meeks 2012-12-20 11:14:17 UTC
Sure cf. the equivalent AOO bug:

This is blocking on Kendy doing some work here I think :-) Kendy ?
Comment 16 Don't use this account, use tml@iki.fi 2012-12-20 11:37:21 UTC
Well, that AOO commit doesn't look that much more impressive than my old patches above;) Note the // TODO: implement something useful comments inside the #if 0 blocks.
Comment 17 Don't use this account, use tml@iki.fi 2012-12-20 11:44:09 UTC
The difficulty here is not the code to just enable full-screen as such (a dozen or so lines), but to decide how this kind of full-screen state should interact with LO's existing non-system full-screen feature. See comment #1.
Comment 18 Michael Meeks 2012-12-20 11:54:38 UTC
> Well, that AOO commit doesn't look that much more impressive
> than my old patches above;) 

Ah drat - I read too quickly and didn't notice them :-) certainly we should use your work instead. Presumably having something here is better than nothing, how do we move forward ? poke UX advise giving them a "this" vs. "nothing" option for 4.0 ? :-)
Comment 19 Don't use this account, use tml@iki.fi 2012-12-20 17:27:20 UTC
Actually the AOO patch looks a bit cleaner. Well, that was my first impression, based on the fact that it doesn't use objc_msgSend() to blindly send a message that isn't implemented before 10.7 like mine does, but checks with [NSWindow respondsToSelector:] and only if that is true, then uses [NSWindow performSelector:]. 

But when I try out how it behaves, there is some serious confusion in window state management and bad interaction with LO's own View:Full Screen. I'll check how my patch works, I don't recall any more. Maybe commit some suitable amalgamation of them...
Comment 20 Don't use this account, use tml@iki.fi 2012-12-20 18:34:30 UTC
Hmm, both my old patch and the AOO one work weirdly in some circumstances. Hard to say what to do... Just push in something so that we can brag "we have Mac OS X full-screen support", or actually think hard how it should interact with the current View:Full Screen thingie, and make sure that nothing weird happens?
Comment 21 Pete K. 2012-12-20 18:40:35 UTC
(In reply to comment #20)
> Hard to say what to do... Just push in something so that we can brag "we
> have Mac OS X full-screen support", or actually think hard how it should
> interact with the current View:Full Screen thingie, and make sure that
> nothing weird happens?

"Do it right" should always prevail over "get it done". This shouldn't be a showstopper for anybody (certainly isn't for me, and I put the original bug in).
Comment 22 Don't use this account, use tml@iki.fi 2012-12-21 11:43:05 UTC
Actually, I think the AOO patch is quite buggy... it uses performSelector:withObject: to call the setCollectionBehavior method. That method takes an integer (NSWindowCollectionBehavior bit mask) as parameter, but it passes performSelector:withObject: an NSNumber object (pointer)... So presumably what actually happens in the AOO code is that the NSNumber pointer is interpreted as the bit mask, and (sometimes? always?) by coincidence it happens to have the "right" bit on that makes the full-screen decoration to appear. Heh.

So, either one should just use objc_msgSend() as in my patch to be on a lower level, or the verbose NSInvocation API. Hmm.
Comment 23 Not Assigned 2012-12-21 13:36:34 UTC
Tor Lillqvist committed a patch related to this issue.
It has been pushed to "master":


fdo#39983: Support Mac OS X 10.7 full-screen mode

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
Affected users are encouraged to test the fix and report feedback.
Comment 24 Emir Sarı (away) 2012-12-24 12:45:59 UTC
Created attachment 72070 [details]
Draw in Fullscreen mode

Freshly tested, working like a charm. :)

But one thing, an extra white area appears when taken to full screen mode (see screenshot), it would be great to get rid of that area to maintain a seamless full-screen experience. 

Other than that perfect it seems.
Comment 25 Emir Sarı (away) 2012-12-24 13:05:04 UTC
One glitch:

When using the old full screen feature, LO switches to OS FS mode, but the small "Exit Full Screen" dialog box still stays open. So if I try to switch to normal mode using Mac OS X FS button, it exits full screen, but toolbars are not visible, and "Exit Full Screen" dialog is still open. I still have to press that button once more for toolbars to become visible. 

I think LO Full Screen button should be removed, and replaced by the OS full screen functions totally.
Comment 26 Emir Sarı (away) 2013-01-14 18:55:48 UTC
Seems broken on Version (Build ID: 69f2f50c99ba218b185d94b118b38ea92b6560a)
TinderBox: MacOSX-Intel@1-built_no-moz_on_10.6.8, Branch:master, Time: 2013-01-11_10:28:50. 

View - Full Screen does not trigger it either. Just the usual old full screen feature.
Comment 27 Don't use this account, use tml@iki.fi 2013-01-16 08:05:47 UTC
The patch from comment #23 had to be reverted, see bug #58963. So yeah, we are back were we started.
Comment 28 Frantisek Erben 2013-01-18 12:41:23 UTC
(In reply to comment #27)
> The patch from comment #23 had to be reverted, see bug #58963. So yeah, we
> are back were we started.

In case of delay this fix to 4.1 you should update documentation page https://wiki.documentfoundation.org/ReleaseNotes/4.0
Comment 29 Emir Sarı (away) 2013-04-27 12:33:55 UTC
I've tested AOO latest builds and FS feature looks fine actually. The annoying extra bar above the main toolbar still exists but it shows all the toolbars, including the newly side pane, and works as expected. I'll test it further, and if there are any requests about specific tests, I can perform.
Comment 30 Emir Sarı (away) 2013-04-27 12:36:38 UTC
One thing, in AOO old FS feature and the OS X FS feature are still separate behaviours; this should be noted. So, this needs resolving, yeah.
Comment 31 Don't use this account, use tml@iki.fi 2013-04-29 09:07:35 UTC
Does the problem described in bug #58963 happen in AOO?
Comment 32 Emir Sarı (away) 2013-04-29 16:51:25 UTC

No, it does not occur. But after further playing with documents on AOO, I've realised that FS feature is not reliable as it should be. The FS icon has disappeared and I cannot find a way to make it re-appear. Before that it started acting totally random, if a document crashed and then recovered FS icon disappeared again. FS icon sometimes appeared on the start screen, sometimes not. 

It would be great if someone else could test AOO[1] behaviours, but at the moment I've changed my mind. 

Comment 33 Jorendc 2013-05-02 14:46:38 UTC
*** Bug 64152 has been marked as a duplicate of this bug. ***
Comment 35 Emir Sarı (away) 2013-07-29 13:41:07 UTC
Very exciting news. 

I wonder how will this new implementation will behave with the existing FS mode. AOO completely messed it up, NeoOffice implementation with toolbars on seems pretty decent. 

But I think existing FS feature should be completely disabled for Mac, unless we will have a "Reading Mode" kind of thing.
Comment 36 Don't use this account, use tml@iki.fi 2013-07-29 14:46:51 UTC
You do realize that "this new implementation" *is* the AOO one, right?
Comment 37 Emir Sarı (away) 2013-07-29 14:52:31 UTC
I haven't checked in detail, but I can tell that current implementation in AOO is not the most UX friendly one. But I still would not comment until I see this feature in LO master build.
Comment 38 Luis Villa 2013-07-30 17:25:50 UTC
Dumb question, but where are nightly Mac builds hosted? I'd like to play with the imported patch, but the directories at http://dev-builds.libreoffice.org/daily/master/ all seem to be empty. :/
Comment 39 Emir Sarı (away) 2013-08-01 08:25:09 UTC
Created attachment 83419 [details]
SS, missing toolbar

Bad behaviours:

1.When switched to FS, a blank white bar is left at the top of the screen, which is very annoying to see.
2. When in OS X FS, clicking View - Full Screen switches to LO full screen view, expected behaviour would be turn off the OS X FS, or an option could be added for this to select between LO FS or OS X FS (turn off).
   a. If we try to turn off the OS X FS by using the LO FS toolbar, then the only thing left is OS X blank texture screen. 
   b. Various scenarios in playing simultaneously with both features messes up the screen, SS attached. 
3. When in LO FS, trying to switch to OS X FS does not work.
4. And two FS features at the same time will confuse users. 

Also LO FS feature has a recent bug that removes the toolbars when turning it off, also that is very annoying. Added to See Also field.

So, it would be nice to address these issues, or to decide at least how will it behave, otherwise what's left will be a bad UX experience, and frustrated users I guess.
Comment 40 Thomas van der Meulen 2013-08-19 16:31:00 UTC
*** Bug 68284 has been marked as a duplicate of this bug. ***
Comment 41 Thomas van der Meulen 2013-08-19 16:33:06 UTC
It looks like this is fixed in LibreOffice 4.2 master version:
Build ID: 70ef99c447fcdb73ecadb8b3afd251ef8021a6cc
TinderBox: MacOSX-X86_64@43, Branch:master, Time: 2013-08-17_23:57:08

Should this bugs status be  changed to closed/resolved fixed?
Comment 42 Don't use this account, use tml@iki.fi 2013-08-19 17:20:11 UTC
Read comment #35 and comment #36. I would not call this bug fixed until the full-screen mode actually works nicely, which it doesn't as Emir describes in comment #39.
Comment 43 Thomas van der Meulen 2013-08-20 13:27:24 UTC
Oké sorry for the noise then...
Comment 44 Erkan 2013-08-22 23:29:46 UTC
openOffice 4.0 has Full Screen on Mac OSX
Comment 45 Tor Lillqvist 2013-08-23 11:26:45 UTC
@Erkan: Read comment #42. Maybe if you make your web browser full-screen you can see it better?
Comment 46 Erkan 2013-08-23 14:22:10 UTC
LibreOffice without "Full Screen" pictogram:

openOffice.org with "Full Screen" pictogram:

Full Screen pictogram can you see top right.
Comment 47 Tor Lillqvist 2013-08-23 14:42:35 UTC
@Erkan: Did you notice the "4.2" in comment #41?

And I do think anybody interested in this bug is fully aware how the full-screen thingie in the status bar looks and works (in proper full-screen -aware applications, like Safari, Aperture, Xcode etc, to mention some of Apple's own).
Comment 48 Erkan 2013-08-23 16:30:53 UTC
Yes and I want try with LO 4.2 but nothing find on the website :/
Comment 49 Emir Sarı (away) 2013-08-23 16:51:44 UTC
(In reply to comment #48)
> Yes and I want try with LO 4.2 but nothing find on the website :/


You can find daily builds here.
Comment 50 Erkan 2013-08-23 17:29:44 UTC
Yes! this béta/dev for LO 4.2 has full screen (-:
Comment 51 Erkan 2013-08-24 21:07:44 UTC
Do you know when is LO 4.2 be release?
Comment 52 Tor Lillqvist 2013-08-25 18:35:29 UTC
Comment 53 retired 2013-11-12 09:09:01 UTC
Changing target from 4.1 to 4.2.

@Tor: I know you said sth about this question earlier, but don't you think this bug here should be closed and the issues described by Emir in comment 39 put into into separate bug reports? Afaik that's the standard policy. If needed we can create a meta bug for OS X fullscreen bugs then.
Comment 54 Norbert Thiebaud 2014-03-14 06:12:58 UTC
works on master
Comment 55 Nick Hibma 2014-05-15 07:34:20 UTC
In LibreOffice 4.2.4 the Mac OS X fullscreen mode is only accessible through the button on the righthandside of the top bar for the window, not through the View menu. In Neo Office there are 2 menu entries to switch to either mode (or was that Chrome?).

Is this intentional? Why is the (IMHO silly) traditional fullscreen mode with the floating 'fullscreen' button (*) still there?

If we could finalise the decision in this bug report to either 'leave as-is because...' or 'yes, will change' that would be great.

(*) The button says 'fullscreen' but switches to 'windowed' mode by the way.
Comment 56 Tor Lillqvist 2014-05-15 07:44:44 UTC
@Nick: As I have said right from the start, yes, in order to "support" (personally I loathe that word, and would rather say "provide" perhaps) the OS X full-screen mode *properly*, "we" (meaning "anybody who is funded or otherwise bothers to do the work") should also get rid of LO's own full-screen mode, and correspoindingly make sure that when in the OS full-screen mode, corresponding changes to the UI are done, too. My personal opinion is that until that is done, we should just not bother with the OS X full-screen mode. It is not worth it as currently implemented.
Comment 57 Nick Hibma 2014-05-15 07:52:46 UTC
@Tor: Your personal opinion aside about whether or not fullscreen mode is useful (*) the mode as is is useful to some. With the timesheet in a separate desktop I am already very happy!

You are talking about funding: with basic support done people can actually start whining about it, and whining will focus attention and funding. My statement tries to keep this issue alive and focus on the next little step that could be taken here.

(*) Personally I -love- fullscreen mode because I am easily distracted by other windows. I am a multi-tasker at heart and have been (currently there is tripwire processing a machine, a number of terminals with unfinished sysadmin stuff, mail, web surfing windows, spreadsheet with my timesheet, itunes backing up my phone, todo list, etc.)
Comment 58 Tor Lillqvist 2014-05-15 08:02:24 UTC
I am not arguing that full-screen mode in applications is not useful. It is, very much so, *when implemented sanely*. I use full-screen mode about half of the time in an Aperture session, now and then in Safari, and all the time when viewing photos, for instance.

What I mean is that as currently implemented in LibreOffice, which is a quick hack, it is not necessarily that useful.
Comment 59 Alex Thurgood 2014-10-22 08:34:12 UTC
FWIW, in Yosemite, clicking on the Window expand button (green one), makes the application go fullscreen (and vice-versa). 

However, we are still left with a blank bar at the top of the screen, see bug 76476 for that.
Comment 60 Tor Lillqvist 2014-10-22 08:40:08 UTC
Comment #56 pretty much sums up my opinion, still.
Comment 61 steve -_- 2015-11-13 11:12:45 UTC
Fullscreen is there. It doesn't work great, but it's there. Thus I suggest to kill this monster bug.

Any remaining issues (and there are a few) should be dealt with in separate bugs (following the "one problem per bug" rule).

The white top line bug is 10.8 specific. It's gone on 10.11 btw. So anybody effected should consider doing the free update to 10.11, which is recommended anyways since it has a ton of important security fixes.